<template>
    <div>
        <v-row class="mb-4 mt-1" style="align-items: center; z-index: 10; position: fixed; right: 1%">
            <v-btn rounded elevation="5" color="orange" class="ml-1 mr-1 white--text float-left" @click="goToLesson()">
                <v-icon>mdi-chevron-left</v-icon>
                {{ $t("LNG_EDITOR_RETURN") }}
            </v-btn>
            <v-btn v-show="canSave" rounded elevation="5" color="success" class="white--text mr-3" @click="save">
                {{ $t("LNG_EDITOR_BUTTON") }}
            </v-btn>
        </v-row>

        <vue-easymde v-model="content" ref="markdownEditor" :configs="configs"
                     class="markdownEditor" style="padding-top: 42px; max-width: 100%"/>
    </div>
</template>

<script>
import { mapGetters } from "vuex";
import { SET_LESSONS } from "@/store/mutations.type";
import Services from "@/services/api";
import VueEasymde from "vue-easymde";
import { API_URL } from '@/services/api/index';

export default {
    name: "LessonEditor",
    components: {
        VueEasymde
    },
    data() {
        return {
            // config object for VueEasyMDE component see the doc for better explanation
            configs: {
                toolbar: [
                    "bold", "italic", "heading", "|",
                    "quote", "unordered-list", "ordered-list", "|",
                    "link", "upload-image", "|",
                    "preview", "side-by-side", "fullscreen", "|",
                    "guide"
                ],
                toolbarTips: true,
                placeholder: "Entrez votre text ici",
                autofocus: true,
                indentWithTabs: true,
                tabSize: 4,
                lineWrapping: true,
                uploadImage: true,
                imageUploadFunction: this.addFile,
                imageUploadEndpoint: `${ API_URL }/media`,
                imageMaxSize: 1024*1024*8, // 8mb
                // Alert box for URLs
                promptURLs: true,
                spellChecker: false,
                styleSelectedText: true,
                autosave: {
                    enabled: true,
                    delay: 1000,
                    uniqueId: "lessonEditor"
                },
                sideBySideFullscreen: false
                // forceSync: true,
            },
            // lesson in markdown form
            md: "",
            // record of the lesson before modification have been made, updated after saving
            oldLesson: {},
            // lesson have been modified once, if true then we show a save action notification
            modified: false,
            canSave: false
        }
    },
    computed: {
        ...mapGetters(['lessons']),
        content: {
            get: function () {
                return this.md
            },
            set: function (newContent) {
                this.md = newContent

                if (!this.canSave) {
                    this.canSave = true;

                }
            }
        }
    },
    async beforeMount() {
        await this.init();
    },
    async mounted() {
        this.$refs.markdownEditor.easymde.toggleSideBySide();
    },
    methods: {
        async init() {
            await this.setLesson();

            const lessonId = this.$route.params.lessonId || 1;

            this.lessons.forEach(lesson => {
                if (lesson.id == lessonId) {
                    this.oldLesson = lesson;
                }
            })

            this.md = this.fromJSONToMd(this.oldLesson);
        },
        goToLesson() {
            /*
            seule manière que j'ai trouvé pour que ça save les data sans crash par la
            suite (Si on go à l'id lesson et que celui-ci n'est pas 1, ça crash,
            sinon ça marche mais ça save pas, du coup on fait juste un retour arrière)
            */
            this.$router.go(-1);
        },
        addFile(file, onSuccess, onError) {
            const currThis = this;
            let formData = new FormData();

            formData.append('file', file);
            formData.append('file_name', file.name);

            let request = new XMLHttpRequest();
            request.open('POST', this.configs.imageUploadEndpoint);
            request.setRequestHeader('Authorization', 'Bearer ' + this.$store.getters.authentication);
            request.onload = function () {
                let response = {};
                try {
                    response = JSON.parse(this.responseText);
                } catch (error) {
                    onError(currThis.$t("LNG_MEDIA_ERROR"));
                    return;
                }
                if (this.status === 200 && response.path) {
                    onSuccess(API_URL + response.path);
                } else {
                    onError(currThis.$t("LNG_MEDIA_ERROR"));
                }
            };

            request.onerror = function (event) {
                onError(currThis.$t("LNG_MEDIA_ERROR"));
            };

            request.send(formData);
        },
        async setLesson(lessonId, id) {
            if (!id) {
                id = this.$route.params.id;
            }

            // get Lessons from a field after selecting one
            const lessons = await Services.Lesson.getLessonByField(id)
                .catch(() => {
                    this.$router.push({ name: "404 Not found" })
                });

            this.$store.commit(SET_LESSONS, lessons);
        },
        fromJSONToMd({ title, paragraphs }) {
            let md = "";

            md += `# ${ title }\n`;
            paragraphs.forEach(({ title, titleSize, content }) => {
                md += ("#".repeat(titleSize) + " " + title + "\n");
                md += (content + "\n");
            })
            return md;
        },
        fromMdToJSON(md) {
            let splits = md.split('\n')

            // Fixme: find a better way
            // splits = splits.filter(item => item !== "")
            splits.forEach(item => {
                if (item === "")
                    item = "\n";
            })

            return splits.reduce(({ paragraphs, title }, item) => {
                if (item.startsWith('#')) {
                    if(!title) {
                        title = item.slice(1).trimStart()
                    } else {
                        const newParagraph = {
                            title: "",
                            content: "",
                            title_size: 0
                        }
                        for (let letter of item) {
                            if (letter !== '#') {
                                break;
                            }
                            newParagraph.title_size++;
                        }
                        newParagraph.title = item.slice(newParagraph.title_size).trimStart()
                        paragraphs.push(newParagraph)
                    }
                } else if (paragraphs.length > 0) {
                    paragraphs[paragraphs.length - 1].content = paragraphs[paragraphs.length - 1].content + item + '\n'
                }
                return {
                    title,
                    paragraphs
                }
            }, {
                title: "",
                paragraphs: [],
            })
        },
        /**
         * compare old lesson to new lesson
         * return an object that contains paragraph to delete, to add/create, to possibly modify
         * */
        getDiff(oldLesson, newLesson) {
            const deleted = []
            const added = []
            const modified = []

            if (newLesson.paragraphs.length > oldLesson.paragraphs.length) {
                let index = 0

                for (; index < oldLesson.paragraphs.length; index++) {
                    const { id } = oldLesson.paragraphs[index]
                    const { title, title_size, content } = newLesson.paragraphs[index]

                    modified.push({
                        id,
                        title,
                        title_size,
                        content,
                        order: index + 1
                    })
                }
                for (; index < newLesson.paragraphs.length; index++) {
                    const { title, title_size, content } = newLesson.paragraphs[index]

                    added.push({
                        title: title,
                        title_size: title_size,
                        content: content,
                        order: index + 1
                    })
                }
            } else if (newLesson.paragraphs.length - oldLesson.paragraphs.length < 0) {
                let index = 0
                for (; index < newLesson.paragraphs.length; index++) {
                    const { id } = oldLesson.paragraphs[index]
                    const { title, title_size, content } = newLesson.paragraphs[index]

                    modified.push({
                        id,
                        title: title,
                        title_size: title_size,
                        content: content,
                        order: index + 1
                    })
                }
                for (; index < oldLesson.paragraphs.length; index++) {
                    const { id } = oldLesson.paragraphs[index]


                    deleted.push({
                        id
                    })
                }
            } else {
                let index = 0

                for (; index < newLesson.paragraphs.length; index++) {
                    const { id } = oldLesson.paragraphs[index]
                    const { title, title_size, content } = newLesson.paragraphs[index]

                    modified.push({
                        id,
                        title: title,
                        title_size: title_size,
                        content: content,
                        order: index + 1
                    })
                }
            }
            return {
                added,
                deleted,
                modified
            }
        },
        async save() {
            const payload = this.fromMdToJSON(this.content)
            const { added, deleted, modified } = this.getDiff(this.oldLesson, payload)

            added.forEach(paragraph => {
                Services.Paragraph.postParagraph({
                    lesson_id: this.oldLesson.id,
                    type: 'TXT',
                    ...paragraph
                })
            })
            deleted.forEach(paragraph => {
                Services.Paragraph.deleteParagraph(paragraph.id)
            })
            modified.forEach(paragraph => {
                Services.Paragraph.patchParagraph(paragraph)
            })

            // make the api call to save the new paragraphs within the lesson
            await this.init();
            this.canSave = false;
        }
    },
}
</script>

<style>
.markdownEditor img {
    width: 100%;
}
</style>


<style type="scss" scoped>
@import "~easymde/dist/easymde.min.css";
</style>
